%Delta Value Compression
clear all;close all;

%open file of sample data
fid=fopen('BP_Sample1.txt');

%open file to write compressed data to
fid2=fopen('dvcompressed.txt','w');

%open file to write original data to compare to file size of compressed
%data
fid3=fopen('dvcompare.txt','w');
[A, length1]=fscanf(fid,'%f');


%%encoding algorithm
prev=0;
size_B=0;
count=1;
for i=1:length1
    if i==1
        size_B=size_B+fprintf(fid2,'%g\r\n',A(i));
        prev=A(i);
        B(count)=A(i);
        count=count+1;
    else
        delta=prev-A(i);
        size_B=size_B+fprintf(fid2,'%g\r\n',delta);
        prev=A(i);
        B(count)=delta;
        count=count+1;
    end
end

%size of comparison file
size_A=fprintf(fid3,'%g\r\n',A);

%scale sizes from bytes to kilobytes
size_A=size_A/1000;
size_B=size_B/1000;

%calculate compression ratio
compression_ratio=size_B/size_A*100;

%display results of compression
fprintf('\nDelta Value Compression Results:\n\n')
fprintf('Original File Size = %3.1fKb\n',size_A)
fprintf('Compressed File Size = %3.1fKb\n',size_B)
fprintf('Compression Ratio = %2.1f\n',compression_ratio)

%display results graphically
figure('Name','File Compression Comparison');subplot(2,1,1);plot(A(1:250));
axis([0,250,0,130]);
title('Original File');
subplot(2,1,2);plot(B(1:250));
axis([0,250,-5,130]);
title('Compressed File');

%close files
fclose(fid);
fclose(fid2);
fclose(fid3);

%code to extract compressed file, and compare to original - if equal,
%demonstrates accuracy of compression ratio
if(dv_extract(fopen('dvcompressed.txt')))
    fprintf('\nExtraction Results:\nExtracted file is equal to original\n');
end