%Matlab function to extract compressed data from delta value compression,
%and compare to original file to see if the two are equal
%Inputs: file ID of file to be extracted
%Outputs: Boolean value result = 1 if extracted file is equal to original
%                              = 0 if extracted file does not equal
%                              original

function result = dv_extract(fid)

%open file to write to for extracted data
fid2=fopen('dv_extracted.txt','w');

[A, length1]=fscanf(fid,'%f');
fprintf(fid2,'%6g\r\n',A(1));
val=A(1);
for i=2:length1
    val=val-A(i);
    if abs(val)<0.005
        fprintf(fid2,'0\r\n');
    else
        fprintf(fid2,'%g\r\n',val);
    end
end

fid3=fopen('dvcompare.txt');
B=fscanf(fid3,'%f');
fclose(fid2);
fid2=fopen('dv_extracted.txt');
C=fscanf(fid2,'%f');

%returns 1 if extracted file is equal to original, and 0 if not
result=isequal(B,C);

%graphically compare extracted and original files
figure('Name','File Extraction Comparison');subplot(2,1,1);plot(B(1:500));
axis([0,500,min(B),max(B)]);
title('Original File');
subplot(2,1,2);plot(B(1:500));
axis([0,500,min(C),max(C)]);
title('Extracted File');

%close files
fclose(fid);
fclose(fid2);
fclose(fid3);