%Difference Value Compression then Run-Length Encoding
clear all;close all;
fid=fopen('BP_Sample1.txt');
fid2=fopen('dvcompressed.txt','w');
fid3=fopen('dvcompare.txt','w');
[A, length1]=fscanf(fid,'%f');

%%DV encoding algorithm
prev=0;
size_B=0;
count=1;
for i=1:length1
    if i==1
        size_B=size_B+fprintf(fid2,'%g\r\n',A(i));
        prev=A(i);
        B(count)=A(i);
        count=count+1;
    else
        delta=prev-A(i);
        size_B=size_B+fprintf(fid2,'%g\r\n',delta);
        prev=A(i);
        B(count)=delta;
        count=count+1;
    end
end

size_A=fprintf(fid3,'%g\r\n',A);
size_A=size_A/1000;
size_B=size_B/1000;
orig_size=size_A;
compression_ratio=size_B/size_A*100;
fprintf('\nDelta Value Compression Results:\n\n')
fprintf('Original File Size = %3.1fKb\n',size_A)
fprintf('Compressed File Size = %3.1fKb\n',size_B)
fprintf('Compression Ratio = %2.1f\n',compression_ratio)

figure('Name','File Comparison');subplot(3,1,1);plot(A(1:250));
axis([0,250,0,130]);
title(['Original File L=',num2str(length(A))]);
subplot(3,1,2);plot(B(1:250));
axis([0,250,-5,130]);
title(['Compressed File L=',num2str(length(B))]);

fclose(fid);
fclose(fid2);
fclose(fid3);

%RLE Compression
clear A B;
fid=fopen('dvcompressed.txt');
fid2=fopen('rle_dvcompressed.txt','w');
fid3=fopen('rle_dvcompare.txt','w');
[A, length1]=fscanf(fid,'%f');
%%encoding algorithm
count=0;
size_B=0;
countB=1;
for i=1:length1
    if count==0
        prev=A(i);
        count=1;
    else
        if prev==A(i)
            count=count+1;
        elseif count==1
            size_B=size_B+fprintf(fid2,'%g\n',prev);
            count=1;
            B(countB)=prev;
            countB=countB+1;
        else
            size_B=size_B+fprintf(fid2,'*%g\n%g\n',count,prev);
            B(countB)=count;
            B(countB+1)=prev;
            countB=countB+2;
            count=1;
        end
    end
prev=A(i);
end

if count==1
    size_B=size_B+fprintf(fid2,'%g\n',prev);
    B(countB)=prev;
else
    size_B=size_B+fprintf(fid2,'*%g\n%d\n',count,prev); %to print final values
     B(countB)=count;
     B(countB+1)=prev;
end

size_A=fprintf(fid3,'%g\r\n',A);

size_A=size_A/1000;
size_B=size_B/1000;
compression_ratio=size_B/size_A*100;
fprintf('\nRun-Length Compression Results:\n\n')
fprintf('Original File Size = %3.1fKb\n',size_A)
fprintf('Compressed File Size = %3.1fKb\n',size_B)
fprintf('Compression Ratio = %2.1f\n',compression_ratio)

subplot(3,1,3);plot(B(1:250));
axis([0,250,-5,130]);
title(['RLE then DV Compressed File L=',num2str(length(B))]);

total_compression=size_B/orig_size*100;

fprintf('\nOverall Compression Results:\n\n')
fprintf('Original File Size = %3.1fKb\n',orig_size)
fprintf('Compressed File Size = %3.1fKb\n',size_B)
fprintf('Compression Ratio = %2.1f\n',total_compression)


fclose(fid);
fclose(fid2);
fclose(fid3);
