%RLE Compression
clear all;close all;

%open file of sample data
fid=fopen('BP_Sample1.txt');

%open file to write compressed data to
fid2=fopen('rlecompressed.txt','w');

%open file to write original data to compare to file size of compressed
%data
fid3=fopen('rlecompare.txt','w'); 
[A, length1]=fscanf(fid,'%f');

%%encoding algorithm
%initializes count instead of firstTime flag that is implemented in java
%code
count=0;
size_B=0;
countB=1;
for i=1:length1
    if count==0
        prev=A(i);
        count=1;
    else
        if prev==A(i)
            count=count+1;
        elseif count==1
            size_B=size_B+fprintf(fid2,'%g\n',prev);
            count=1;
            B(countB)=prev;
            countB=countB+1;
        else
            size_B=size_B+fprintf(fid2,'*%g\n%g\n',count,prev);
            B(countB)=count;
            B(countB+1)=prev;
            countB=countB+2;
            count=1;
        end
    end
prev=A(i);
end

%code to deal with last value not taken care of in loop
if count==1
    size_B=size_B+fprintf(fid2,'%g\n',prev);
    B(countB)=prev;
else
    size_B=size_B+fprintf(fid2,'*%g\n%d\n',count,prev); %to print final values
     B(countB)=count;
     B(countB+1)=prev;
end

%size of comparison file
size_A=fprintf(fid3,'%g\r\n',A);

%scale sizes from bytes to kilobytes
size_A=size_A/1000;
size_B=size_B/1000;

%calculate compression ratio
compression_ratio=size_B/size_A*100;

%display results of compression
fprintf('\nRun-Length Compression Results:\n\n')
fprintf('Original File Size = %3.1fKb\n',size_A)
fprintf('Compressed File Size = %3.1fKb\n',size_B)
fprintf('Compression Ratio = %2.1f\n',compression_ratio)

%display results graphically
figure('Name','File Comparison');subplot(2,1,1);plot(A(1:250));
axis([0,250,0,130]);
title(['Original File L=',num2str(length(A))]);
subplot(2,1,2);plot(B(1:250));
axis([0,250,0,130]);
title(['Compressed File L=',num2str(length(B))]);

%close files
fclose(fid);
fclose(fid2);
fclose(fid3);
